﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;

namespace ledyak
{
    public partial class Form1 : Form
    {
        String[] ports;
        SerialPort Sport;
        bool isConnected = false;
        public static readonly List<string> SupportedBaudRates = new List<string>
        {     
        "9600",
        "19200",
        "38400",
        "57600",
        "115200", 
        };


        public Form1()
        {
            InitializeComponent();
            getAvailableComPorts();
            disableControls();
            groupBox1.Enabled = true;

            foreach (string port in ports)
            {
                comboBox1.Items.Add(port);
                //Console.WriteLine(port);
                if (ports[0] != null)
                {
                    comboBox1.SelectedItem = ports[0];
                }
            }

            foreach (string baud in SupportedBaudRates)
            {
                comboBox2.Items.Add(baud);
                if (ports[0] != null) //port boş ise baud da boşuna getirmesin
                {
                    comboBox2.SelectedItem = SupportedBaudRates[0];
                }
            }

           // aGauge1.Value = 75;
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        void getAvailableComPorts()
        {
            ports = SerialPort.GetPortNames();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)

        {

            if (!isConnected)
            {
                connectToArduino();
            }
            else
            {
                disconnectFromArduino();
            }         
            
        }

        private void disconnectFromArduino()
        {
            isConnected = false; 
            Sport.Close();
            button1.Text = "Bağlan";
            disableControls();
            resetDefaults();
            comboBox1.Enabled = true;
            comboBox2.Enabled = true;
        }

        private void connectToArduino()
        {
            try
            {
                string selectedPort = comboBox1.GetItemText(comboBox1.SelectedItem);
                int baudRate = Convert.ToInt32(comboBox2.GetItemText(comboBox2.SelectedItem));
                Sport = new SerialPort(selectedPort, baudRate, Parity.None, 8, StopBits.One);
                Sport.Open();
                button1.Text = "Kes";
                button1.BackColor = Color.Red;
                groupBox1.Enabled = true;
                isConnected = true;
                enableControls();
                comboBox1.Enabled = false;
                comboBox2.Enabled = false;
                

            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message, "Bağlanma Hatası");
                throw;
            }
        }


        private void enableControls()
        {
            checkBox1.Enabled = true; 
            groupBox1.Enabled = true; 

        }

        private void disableControls()
        {
            checkBox1.Enabled = false; 
            groupBox1.Enabled = false; 
        }

        private void resetDefaults()
        {
            checkBox1.Checked = false;
            button1.Text = "Bağlan";
            button1.BackColor = Color.Green;

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (isConnected)
            {
                if (checkBox1.Checked)
                {
                    Sport.Write("i1\n");
                }
                else
                {
                    Sport.Write("i0\n");
                }
            }
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (isConnected)
            {
                if (checkBox2.Checked)
                {
                    Sport.Write("s1\n");
                }
                else
                {
                    Sport.Write("s0\n");
                }
            }
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
        
        }

        private void Form1_Leave(object sender, EventArgs e)
        {

        }

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {

        }

        private void aGauge1_ValueInRangeChanged(object sender, AGaugeApp.AGauge.ValueInRangeChangedEventArgs e)
        {

        }

        private void checkBox3_CheckedChanged_1(object sender, EventArgs e)
        {
            if (isConnected)
            {
                if (checkBox3.Checked)
                {
                    Sport.Write("d1\n");
                }
                else
                {
                    Sport.Write("d0\n");
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

        }
    }
}
