#include "LoRa_E32.h"
#include <SoftwareSerial.h>
SoftwareSerial mySerial(10, 11); // Arduino RX <-- e32 TX, Arduino TX --> e32 RX
LoRa_E32 e32ttl(&mySerial);


String gelenVeri = "";         // a string to hold incoming data
boolean veriTmm = false;


void setup() {
  Serial.begin(9600);
  e32ttl.begin();
  delay(500);
}

void loop() {

  if (veriTmm)
  {
    veriTmm = false;

    struct Signal  {
      char firma[21] = "Fixaj Otomasyon";
      byte aydinlatma[1];
      byte sulama[1];
      byte kapi[1];
    } data;


    if (gelenVeri.equals("i0")) {

      *(byte*)(data.aydinlatma) = 0;

    } else if (gelenVeri.equals("i1")) {

      *(byte*)(data.aydinlatma) = 1;

    } else if (gelenVeri.equals("s0")) {

      *(byte*)(data.sulama) = 0;

    } else if (gelenVeri.equals("s1")) {

      *(byte*)(data.sulama) = 1;

    } else if (gelenVeri.equals("d0")) {

      *(byte*)(data.kapi) = 0;

    } else if (gelenVeri.equals("d1")) {

      *(byte*)(data.kapi) = 1;

    }

    ResponseStatus rs = e32ttl.sendFixedMessage(0, 63, 23, &data, sizeof(Signal));
    Serial.println(rs.getResponseDescription());

    gelenVeri = "";
  }




}

void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read();
    // add it to the inputString:
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar == '\n') {
      veriTmm = true;
    } else {
      gelenVeri += inChar;
    }
  }
}
